[org 100h]
[segment .text]

LH 	equ 112
PH 	equ 200
LINES	equ 23
LINEH	equ 2560

;	push cs
;	pop  ds
	mov  ah, 9		; rychlost
	mov  dx, Text2
	int  21h

klav:	mov  ah, 8		; klavesa
	int  21h
	sub  al, 49
	jc   klav
	cmp  al, 4
	jnc  klav
	cbw
	inc  ax
	mov  word [Rych], ax

	mov  ah, 0Fh
	int  10h
	cbw
	push ax			; uloz rezim
	mov  al, 13h
	int  10h		; nastav graficky rezim

	cld
      	push word 0A000h
	pop  es			; ES - videoram

	mov  al, 6
	out  43h, al
	in   al, 40h
	in   al, 40h
	mov  [Nahoda], ax

	mov  cx, LINES
	mov  dx, LH
leva:	call KrBlok
	add  dx, LINEH
	loop leva
	mov  cx, LINES
	mov  dx, PH
prava:	call KrBlok
	add  dx, LINEH
	loop prava
	mov  cx, 10
	mov  dx, 56440
spodni:	call KrBlok
	add  dx, 8
	loop spodni

	call ITimer		; naves nove IRQ0

Start:	call Random
	mov  cx, 7
	div  cx
	mov  [Blok], dl		; novy blok
	mov  word [Pozice], 144
	mov  word [Otoceni], 0
	call Test1		; vejde se?
	cmp  al, 0
	jnz  konec

wloop:	mov  byte [Barva], 10
	call Kresli
	mov  ah, 1
	int  16h
	jnz  Key
	cmp  byte [Counter], 0
	jnz  wloop
	mov  ax, [Rych]
	mov  bx, 10
	mul  bx
	mov  cx, 70
	sub  cx, ax
	mov  byte [Counter], cl

	mov  byte [Barva], 0
	call Kresli
	add  word [Pozice], LINEH
	call Test1		; na konci?
	cmp  al, 0
	jnz  Lajna
	jmp  wloop
Lajna:	sub  word [Pozice], LINEH
	mov  byte [Barva], 10
	call Kresli
	call Maz		; vymaz lajnu lze-li
	jmp  Start

konec:	call RTimer		; zpatky stare IRQ0

	pop  ax			; vrat rezim
	int  10h

	push cs
	pop  ds
	mov  ah, 9		; vypis score
	mov  dx, Text
	int  21h

	mov  ax, [Score]
	mov  dx, 10
	mul  dx
	call vypis

	mov  ah, 8		; pausa
	int  21h

	ret

Key:	xor  ax, ax		; test klaves
	int  16h
	cmp  ah, 72
	jz   Rotate
	cmp  ah, 75
	jz   Left
	cmp  ah, 77
	jz   Right
	cmp  ah, 80
	jz   Down
	cmp  ah, 1
	jz   konec
	jmp  wloop

Down:	mov  byte [Counter], 0
	jmp  wloop

Rotate: mov  byte [Barva], 0
	call Kresli
	inc  word [Otoceni]
	cmp  word [Otoceni], 4
	jnz  ER
	mov  word [Otoceni], 0
ER:	call Test1
	cmp  al, 0
	jz   jde
	cmp  word [Otoceni], 0
	jnz  ER2
	mov  word [Otoceni], 4
ER2:	dec  word [Otoceni]
	jmp  jde

Left:	mov  byte [Barva], 0
	call Kresli
	sub  word [Pozice], 8
	call Test1
	cmp  al, 0
	jz   jde
	add  word [Pozice], 8
	jmp  jde

Right:	mov  byte [Barva], 0
	call Kresli
	add  word [Pozice], 8
	call Test1
	cmp  al, 0
	jz   jde
	sub  word [Pozice], 8

jde:	jmp  wloop

; Vykresli policko 8x8
; dx - pozice
; meni - DI
KrBlok:	pusha
	mov  di, dx
	mov  al, [Barva]
	mov  bx, 8
krb1:	mov  cx, 8
	rep stosb
	add  di, 312
	dec  bx
	jnz  krb1
	popa
	ret

; Nahodne cislo do AX
Random: push cx
	mov  ax, [Nahoda]
	mov  cx, 5
	mul  cx
	add  ax, 7
	mov  [Nahoda], ax
	pop  cx
	ret

; Nakresli blok
Kresli: pusha
	mov  si, Tab
	mov  ax, [Blok]
	mov  dl, 8
	mul  dl
	add  si, ax
	add  si, [Otoceni]
	add  si, [Otoceni]
	mov  dx, [Pozice]
	mov  bx, 4
	mov  ax, [si]
vnejsi:	mov  cx, 4
smycka:	shl  ax, 1
	jnc  dalsi
	call KrBlok
dalsi:	add  dx, 8
	loop smycka
	add  dx, 2528
	dec  bx
	jnz  vnejsi
	popa
	ret

; navesi na IRQ0 timer
ITimer:	push es
	mov ax, 351Ch
	int 21h
	mov word [Old1Ch], bx
	mov word [Old1Ch+2], es
	pop es
	mov ah, 25h
	mov dx, int1Ch
	int 21h
	mov dx, 2e9bh			;1193180/100Hz
	mov al, 034h
	out 043h, al
	mov al, dl
	out 040h, al
	mov al, dh
	out 040h, al
        ret

; obsluha preruseni
int1Ch:	mov al, [cs:Counter]
	test al, al
	jz ETimer
	dec al
	mov byte [cs:Counter], al
ETimer:	iret

; vrati stare IRQ 0
RTimer:	mov ax, 251ch
	lds dx, [Old1Ch]
	int 21h
	mov al, 034h
	out 043h, al
	xor al, al
	out 040h, al
	out 040h, al
	ret

; testuje, zda blok nezasahuje do jinych
; Al = 0 OK
Test1:	mov  si, Tab
	mov  ax, [Blok]
	mov  dl, 8
	mul  dl
	add  si, ax
	add  si, [Otoceni]
	add  si, [Otoceni]
	mov  di, [Pozice]
	mov  dx, [si]
	mov  bx, 4
	xor  al, al
vne1:	mov  cx, 4
sm1:	shl  dx, 1
	jnc  dal1
	scasb
	jz   dal1
	inc  al
	jmp  kon1
dal1:	add  di, 8
	loop sm1
	add  di, 2528
	dec  bx
	jnz  vne1
kon1:	ret

; hleda a maze linky
Maz:	mov  word [Pozice], 56120	; pod spodnim radkem
	mov  bp, [Rych]
all:	mov  di, [Pozice]
	mov  cx, 10
	xor  al, al
linka:	scasb
	jz   dal
	add  di, 7
	loop linka
	call Posun
	add  word [Score], bp
	inc  bp
	mov  cx, [Score]
	mov  al, 20
	mov  di, 61440
	rep stosb
	jmp  all
dal:	sub  word [Pozice], LINEH
	jnc  all
	ret

Posun:	pusha
	push ds
	mov  di, [Pozice]
	mov  si, [Pozice]
      	push word 0A000h
	pop  ds			; ES - videoram
	sub  si, LINEH
cykl:	mov  cx, 80
	rep  movsb
	sub  di, 400
	sub  si, 400
	cmp  si, LINEH
	jnc  cykl
	pop  ds
	popa
	ret	

; vypise cislo v AX (textovy rezim)
vypis:	xor   cx, cx
	mov   bx, 10
decloop: xor   dx, dx
	div   bx
	inc   cx
	push  dx
	cmp   ax, 0
	jnz   decloop
	mov   ah, 02
poploop: pop   dx
	add   dl, 48
	int   21h
	loop  poploop
	ret

Nahoda	dw 1		; nahodne cislo
Pozice	dw 1		; pozice bloku (v pixelech 0-64000)
Blok	db 1		; poradove cislo padajiciho bloku (0-6)
Otoceni	dw 1		; stav otoceni (1-4)
Barva	db 80		; barva (10)
Old1Ch	dd 0		; IRQ 0
Counter	db 100		; pocitadlo (0-255)
Score	dw 0
Rych	dw 1		; rychlost
Text	db "Vase score: $"
Text2	db "Zvolte rychlost 1(nejmensi) az 4$"

Tab	dw	0110011000000000b	; kostka
	dw	0110011000000000b
	dw	0110011000000000b
	dw	0110011000000000b

	dw	0010011001000000b	; levy hak
	dw	0000011000110000b
	dw	0010011001000000b
	dw	0000011000110000b

	dw	0100011000100000b	; Pravy hak
	dw	0000001101100000b
	dw	0100011000100000b
	dw	0000001101100000b

	dw	0111010000000000b	; Levy T
	dw	0110001000100000b
	dw	0001011100000000b
	dw	0100010001100000b

	dw	0111000100000000b	; Pravy T
	dw	0010001001100000b
	dw	0100011100000000b
	dw	0110010001000000b

	dw	0111001000000000b	; Kriz
	dw	0010011000100000b
	dw	0010011100000000b
	dw	0100011001000000b

	dw	1111000000000000b	; Cara
	dw	0100010001000100b
	dw	1111000000000000b
	dw	0100010001000100b